%imacro if 3-*
        %push if
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$iff
        %else
                %assign %$c 0
                %rep (%0 / 3)
                        cmp     %1, %3
                        j%2     near %$iff%$c
                        %rotate 3
                %endrep
                jmp     near %$iff
                %$iff%$c:
        %endif


%endmacro
%imacro ifand 3-*
        %push if
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$iff
        %else
                %rep (%0 / 3)
                        cmp     %1, %3
                        j%-2    near %$iff
                        %rotate 3
                %endrep
        %endif
%endmacro
%imacro else 0
        %ifctx if
                %repl else
                jmp     near %$e
                %$iff:
        %else
                ; %error "Expected 'if' or 'ifand' before 'else'"
        %endif
%endmacro
%imacro endif 0
        %ifctx if
                %$iff:
                %pop
        %elifctx else
                %$e:
                %pop
        %else
                ; %error "Expected 'if' before 'endif'"
        %endif
%endmacro
;***************************

;*************************************************
; HLL macros - while/wend
;
%imacro while 3-*
        %push while
        %$w:
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$x
        %else
                %assign %$c 0
                %rep (%0 / 3)
                        cmp     %1, %3
                        j%2     near %$w%$c
                        %rotate 3
                %endrep
                jmp     %$x
                %$w%$c:
        %endif
%endmacro
%imacro whileand 3-*
        %push while
        %$w:
        %if %0 = 3
                cmp     %1, %3
                j%-2    near %$x
        %else
                %assign %$c 0
                %rep (%0 / 3)
                        cmp     %1, %3
                        j%-2    near %$x
                        %rotate 3
                %endrep
        %endif
%endmacro
%imacro wend 0
        %ifctx while
                jmp     %$w
        %$x:
                %pop
        %else
                ; %error "Expected 'while' before 'wend'"
        %endif
%endmacro

